O_BYTE		EQU     30h		; 
I_BYTE  	EQU     31h
LSB		EQU   	32h	
MSB		EQU     33h
LSBT		EQU 	34h
MSBT		EQU  	35h
Count_Bit       EQU     39h
TmpTemp

#define Spp0_S1       Spp0_Selekt,0               ;       
#define Spp0_S1       Spp0_Selekt,0               ;        
#define Spp0_S1       Spp0_Selekt,0               ; 60, 500   
#define Spp0_S1       Spp0_Selekt,0
#define Spp0_S1       Spp0_Selekt,0
#define Spp0_S1       Spp0_Selekt,0
;======================================================================================

;-------------------------------------------------------------------------------
;                  
;-------------------------------------------------------------------------------
                movfw   count100
                btfsc   STATUS,Z
                goto    run_ds
                decf    count100,F
                goto    ret_it
run_ds          btfsc   Szp2                     ;     
	        return                           ;       
	        btfsc   Szp3                     ;   
	        return                           ;
	        btfsc   Szp4                     ;
	        return                           ;
                bsf     INTCON,GIE               ;     ,       
                movlw   ds_run
                MOVWF   count100
                CALL	DS_Init
	        btfsc	No_dat                   ;   No_dat  -   
	        goto    ret_it                   ;     
                MOVLW	0xCC			;   
	        MOVWF	O_BYTE
                CALL	OUT_BYTE
	        MOVLW	0x44			;    
	        MOVWF	O_BYTE
	        CALL	OUT_BYTE
	        CALL	DS_Init
                btfsc	No_dat
	        goto    ret_it
                MOVLW	0xCC			;   
	        MOVWF	O_BYTE
	        CALL	OUT_BYTE
	        MOVLW	0xBE			;    
	        MOVWF	O_BYTE
	        CALL	OUT_BYTE               	;  
	        CALL 	IN_BYTE
	        MOVWF	LSB     		;    
	        CALL 	IN_BYTE
	        MOVWF	MSB     		;    
	        CALL   	PIN_LO          	;    
	        MOVFW   LSB        		;    LSB
                ANDLW  	h'F0'
                MOVWF	LSBT       		;    LSBT
                SWAPF	LSBT,F     		;   
                MOVFW   MSB         		;    MSB
                ANDLW   h'0F'
                MOVWF  	MSBT        		;    MSBT
                SWAPF	MSBT,F     		;   
                MOVFW  	MSBT        		;    LSBT,   
                IORWF  	LSBT,F       		;       1 
                MOVFW   LSBT
                MOVWF   Con_Temp
                BTFSS	LSBT,7        		;  ?
	        goto    ret_it

                COMF  	LSBT,f       		;     -
                INCF  	LSBT,f          	;         
                BSF    	F_minus      		;    

ret_it
                bsf     INTCON,GIE
                bcf     Spp0                    ;        
                RETURN




;-------------------------------------------------------------------------------
                     ;     1-Wire
;-----------------------------------------------------------------------------------
;-----------------------------------------------------------------------------------
;                 
;-----------------------------------------------------------------------------------
DS_Init
               call   PIN_HI                  ;  RESET
               call   PIN_LO                  ;    
               movlw   0x32                   ; 500 us delay
               call   Delay_10usec
               call   PIN_HI                  ;  
               movlw   0x06                   ; 60 usec delay
               CALL   Delay_10usec
               btfsc  DS18B20                 ;  
               goto   No_ds
               movlw   0x29                   ; 410 us delay
               CALL   Delay_10usec
               return
No_ds          bsf    No_dat
               return
;-----------------------------------------------------------------------------------
;               
;------------------------------------------------------------------------------
IN_BYTE: 
        	MOVLW   0x08                    ;    W
        	MOVWF   Count_Bit
        	CLRF    I_BYTE
IN_BYTE_1:
        	CALL 	PIN_LO
        	NOP
        	CALL 	PIN_HI
        	NOP
        	NOP
        	NOP
        	NOP
        	NOP
        	NOP
                NOP
        	NOP
        	NOP
        	NOP
        	NOP
        	NOP

;                BTFSS 	TERMO_1
        	BCF 	STATUS,C
	        BTFSC 	TERMO_1
        	BSF 	STATUS,C

        	RRF     I_BYTE,F
        	MOVLW 	0x06
        	CALL    Delay_10usec
        	DECFSZ  Count_Bit,F
        	GOTO    IN_BYTE_1
        	MOVFW   I_BYTE         		 ;    W
        	RETURN

;-----------------------------------------------------------------------------------
;               
;------------------------------------------------------------------------------
OUT_BYTE:

        	MOVLW  	0x08
        	MOVWF   Count_Bit
OUT_BYTE_1:
        	RRF     O_BYTE,F
        	BTFSS   STATUS,C
        	GOTO    OUT_0
        	GOTO    OUT_1
OUT_BYTE_2:
        	DECFSZ  Count_Bit,F
        	GOTO    OUT_BYTE_1
        	RETURN
;-------------------------------------------
OUT_0:

        	CALL    PIN_LO
       	        MOVLW   0x06
        	CALL    Delay_10usec
        	CALL    PIN_HI
        	GOTO    OUT_BYTE_2
OUT_1:
        	CALL    PIN_LO
        	CALL    PIN_HI
        	MOVLW 	0x06
        	CALL 	Delay_10usec
        	GOTO    OUT_BYTE_2


;-----------------------------------------------------------------------------------
;                  1-Wire
;------------------------------------------------------------------------------
PIN_HI:
        	BSF     STATUS, RP0    		;   -
        	BSF     TRISIO,2
        	BCF     STATUS, RP0
        	RETURN
;---------------------------------------
PIN_LO:
                BSF    	STATUS, RP0		;   
        	BCF     TRISIO,2
  	        BCF  	STATUS, RP0
	        RETURN

;-----------------------------------------------------------------------------------
;                 W*10 
;------------------------------------------------------------------------------
Delay_10usec                                   ;  10*WREG 
                MOVWF   TmpTemp                ;  4  nop = 1 
Delay_10usec1
                NOP
                NOP
                NOP
                NOP
                NOP
                NOP
                NOP
                DECFSZ  TmpTemp,F         ;   
                GOTO    Delay_10usec1
                RETURN